%Dette er en test
%% Laster inn data til for simulering.

clear all; close all;

load s070401t2000t2300
%load s070401t1030t1400
%load s070401t2000t2100

i1 = find(s2.t==1115);
i2 = find(s2.t==3350);
s2.p_bit(i1:i2) = NaN;
i1 = 1548; i2 = 1885;
s2.p_bit(i1:i2) = NaN;

depth = 1826;
len = s2.l_bit;

%% Trykk 

dt = 1;
%time = s2.t(1):dt:s2.t(end);
time = (s2.t(1):5:s2.t(end))/60/60;

% preallocate
Dph_p = zeros(size(time));
Dph_a = zeros(size(time));
Dp_p = zeros(size(time));
Dp_a = zeros(size(time));

for i = 1:length(time),
    Dph_p(i) = Dph_pipe(depth,s2.p_p(i));
    Dph_a(i) = Dph_ann(depth,s2.p_c(i));

    Dp_p(i) = Dp_pipe(s2.q_p(i),len(i));
    Dp_a(i) = Dp_ann(s2.q_p(i),len(i));
end

%% SIMULATE

dt = 5; % data
h = 0.2; % simulation

time_d = s2.t(1):dt:s2.t(end); % data
time_s = s2.t(1):h:s2.t(end); % simulation
L = length(time_d);
nm = (L-1)*dt/60; numsam = floor(nm*60/h);

% generate reference value vector
time_ref=time_s;
ref=zeros(size(time_s));
for i=1:length(time_s)/2-0.5,
    ref(i)=240;
end
for i=length(time_s)/2+0.5:length(time_s),
    ref(i)=250;
end
%
for i=length(time_s)*3/4+0.25:length(time_s),
    ref(i)=240;
end
%
% Choke
u0 = 29.2;
Cv = 41;
umax = 42.7;

% Parameters
q_r = 0; q_a = 0; % No reservoir inflow, no annulus pump
M_d = 6000;
M_a = 1600;
beta_a = 5000; %15000;
beta_d = 10000; %15000;

% Parameters for PI controllers.

% Downhole pressure controller
Kp_p=0.0008;
Ti_p=10;
Td_p=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Kp_bpp_11=0.0001;
Ti_bpp_11=0.95;
Td_bpp_11=0;

Kp_bpp_12=0.007;
Ti_bpp_12=1;
Td_bpp_12=0;
% Choke valve controller.
Kp_c11=-0.001;          % no flow
Ti_c11=0.02;

Kp_c12=-0.001;        % normal flow
Ti_c12=0.06;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% case 2 fault in choke
% parameters for choke
Kp_c21=-0.00001;        % fault in choke
Ti_c21=0.02;
Kp_c22=-0.00001;        % fault in choke
Ti_c22=0.02;

% case 2 blocked choke valve
% parameters for q>0
Kp_bpp_21=0.04;
Ti_bpp_21=0.9;
Td_bpp_21=0;
% parameters for q=0
Kp_bpp_22=0.000001;
Ti_bpp_22=80;
Td_bpp_22=0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% preallocate
sp_p = zeros(size(time_s));         % simulated valures
sp_c = zeros(size(time_s));
sq_b = zeros(size(time_s));
sq_bpp=zeros(size(time_s));
q_c=zeros(size(time_s));

e1 = zeros(size(time_s));           % controller error 
e2 = zeros(size(time_s));

u_ctest=zeros(size(time_s));        % controller output
u_ctest11=zeros(size(time_s));
u_ctest12=zeros(size(time_s));
u_ctest21=zeros(size(time_s));
u_ctest22=zeros(size(time_s));

u_ptest=zeros(size(time_s));
u_bpp=zeros(size(time_s));
u_bpp11=zeros(size(time_s));
u_bpp12=zeros(size(time_s));
u_bpp21=zeros(size(time_s));
u_bpp22=zeros(size(time_s));

u_cP=zeros(size(time_s));
u_cI=zeros(size(time_s));
u_c11=zeros(size(time_s));
u_c12=zeros(size(time_s));
u=zeros(size(time_s));

y1=zeros(size(time_s));
y2=zeros(size(time_s));


test1= zeros(size(time_s));         % test functions
test2= zeros(size(time_s));
test3= zeros(size(time_s));
test4= zeros(size(time_s));

%Kp_c= zeros(size(time_s));

sp_b = zeros(size(time_s));

q_p=interp1(0:L-1,s2.q_p',0:h/dt:L-1)/1000/60;      % prealocation of data
p_c=interp1(0:L-1,s2.p_c'+1,0:h/dt:L-1);
u_c=interp1(0:L-1,s2.u_c1,0:h/dt:L-1);
len = interp1(0:L-1,s2.l_w,0:h/dt:L-1);
N_RPM = interp1(0:L-1,s2.omega_d,0:h/dt:L-1);
h_block = interp1(0:L-1,s2.h_block,0:h/dt:L-1);
h_bit = interp1(0:L-1,s2.h_bit,0:h/dt:L-1);


depth = 1826;

% Initialization
sp_p(3) = s2.p_p(1)+1;
sp_p(2) = s2.p_p(1)+1;
sp_p(1) = s2.p_p(1)+1;
sp_c(3) = s2.p_c(1)+1;
sp_c(2) = s2.p_c(1)+1;
sp_c(1) = s2.p_c(1)+1;
sq_b(3) = s2.q_p(1)/1000/60;
sq_b(2) = s2.q_p(1)/1000/60;
sq_b(1) = s2.q_p(1)/1000/60;


u_bpp11(3)=0.03;
u_bpp11(1)=0.03;
u_bpp11(2)=0.03;
u_bpp12(3)=0.03;
u_bpp12(1)=0.03;
u_bpp12(2)=0.03;
u_bpp21(3)=0.03;
u_bpp21(1)=0.03;
u_bpp21(2)=0.03;
u_bpp22(3)=0.03;
u_bpp22(1)=0.03;
u_bpp22(2)=0.03;

u_ctest11(1)=u_c(1);
u_ctest11(2)=u_c(1);
u_ctest11(3)=u_c(1);
u_ctest12(1)=u_c(1);
u_ctest12(2)=u_c(1);
u_ctest12(3)=u_c(1);
u_ctest21(1)=u_c(1);
u_ctest21(2)=u_c(1);
u_ctest21(3)=u_c(1);
u_ctest22(1)=u_c(1);
u_ctest22(2)=u_c(1);
u_ctest22(3)=u_c(1);

u_bpp(3)=0.03;
u_bpp(1)=0.03;
u_bpp(2)=0.03;

u_bpp0(i)=0.03;
u_bpp11(i)=0;

u_c0(1)=u_c(1);

u_cI(1)=0;


sp_b(1)=250;
sp_b(2)=250;
sp_b(3)=250;

y2(1)=230;
y2(2)=230;

y=sp_b;

% test kriterier
%q_p=0.03;
u_ctest(1)=u_c(2); % defines a initial value for the controller.
u_ctest(2)=u_c(2);
u_ctest(3)=u_c(2);

q_c(1)=0.03;

% Fault tolerant control
% Starter med en enkel feil. True = antar at det er feil i systemet.
% False =antar at choke ventil fungerer som normalt.

feil = false;
test_1=1;
test_2=1;
df = 1;
f=1;
daf=0;
k=1;

for i = 3:length(time_s),
    %%%%% CONTROLLER %%%%%%%%%%%%%%%%%%%%%
    
    %Defines the controller error
    if i==8500;
        f=2;
    elseif i==20000,
        f=1;
    elseif i==30000,
        f=2;    
    elseif i==42000,
        f=1;           
     end
    
e1(i)=30.33-y1(i-1);  
e2(i)=(ref(i)-y2(i-1)); 

    % nominal controllers.
    % No flow q=0
    u_ctest11(i)=u_ctest11(i-1)+Kp_c11*((e1(i)-e1(i-1)+(test_1*h/(Ti_c11))*(e1(i))));
    if  u_ctest11(i)<0
        u_ctest11(i)=0;
    end 
    u_bpp11(i)=u_bpp11(i-1)*u_bpp11(i-1)+Kp_bpp_11*(e1(i)+e1(i-1))+Kp_bpp_11*(h/Ti_bpp_11)*e1(i);
    if  u_bpp11(i)<0
        u_bpp11(i)=0;
    elseif u_bpp11(i)>0.6
        u_bpp11(i)=0.6;
    end 
    
    % Flow q>0
    u_ctest12(i)=u_ctest12(i-1)+Kp_c12*u_ctest12(i-1)*((e2(i)-e2(i-1)+(test_1*h/(Ti_c12*2))*(e2(i)+e2(i-1))));
    if u_ctest12(i)<0
        u_ctest12(i)=0;
    end     
    u_bpp12(i)=u_bpp12(i-1)+Kp_bpp_12*((e2(i)-e2(i-1))+(test_2*h/(Ti_bpp_12*2)*(e2(i)+e2(i-1)))); 
    if  u_bpp12(i)<-0.4
        u_bpp12(i)=-0.4;
    elseif u_bpp12(i)>0.6
        u_bpp12(i)=0.6;
    end 
    
    % Blocked choke controllers.
 
    u_bpp22(i)=u_bpp22(i-1)*u_bpp22(i-1)+Kp_bpp_22*((e1(i)-e1(i-1))+(test_2*h/(Ti_bpp_22)*(e1(i)))+(Td_bpp_22/h)*(e1(i)-2*e1(i-1)+e1(i-2))); 
    u_bpp21(i)=u_bpp21(i-1)+Kp_bpp_21*((e2(i)-e2(i-1))+(test_2*h/(Ti_bpp_21)*(e2(i)))+(Td_bpp_21/h)*(e2(i)-2*e2(i-1)+e2(i-2)));             
    
    switch df
        case 1            
            if q_p(i)==0,                
                if u_bpp11(i)<0
                    u_bpp(i)=0;
                elseif u_bpp11(i)>0.06
                    u_bpp(i)=0.06;
                else
                    u_bpp(i)=u_bpp11(i);
                end

                sq_bpp(i)=u_bpp(i);
                
                u_ctest(i)=u_ctest11(i);

            else
                
                u_bpp(i)=u_bpp12(i);
                if sign(u_bpp(i-1))==-1,
                    u_bpp(i-1)=-u_bpp(i-1);
                end       
                if u_bpp(i)>0.06,
                    sq_bpp(i)=0.06;
                end 
                
                if u_bpp(i)<0,
                    sq_bpp(i)=0;
                else
                    sq_bpp(i)=u_bpp(i);
                end                  
                u_ctest(i)=u_ctest12(i);   
            end
                   
        case 2        
            if q_p(i)==0,
                u_bpp(i)=u_bpp22(i);
                if u_bpp(i)>0.06,
                    u_bpp(i)=0.06;
                end
                if u_bpp(i)<-0.04,
                    u_bpp(i)=-0.04;
                end
                sq_bpp(i)=-u_bpp(i);

                u_ctest11(i)=u_ctest11(i-1);
                u_ctest12(i)=u_ctest12(i-1);

            else 
                u_bpp(i)=u_bpp21(i);
                u_ctest(i)=u_ctest(i-1);
                u_ctest11(i)=u_ctest11(i-1);
                u_ctest12(i)=u_ctest12(i-1);
                
                if u_bpp(i)>0.06,
                    u_bpp(i)=0.06;
                end
                if u_bpp(i)<-0.04,
                    u_bpp(i)=-0.04;
                end
                sq_bpp(i)=u_bpp(i);            
                u_ctest(i)=u_ctest(i-1);

            end
            

                u_bpp11(i)=u_bpp(i)-u_bpp11(i);

                u_bpp22(i)=u_bpp(i)-u_bpp22(i);
            
    end
    
    %%%%%%%%% FAULT SIMULATION %%%%%%%%%%%%%%%%%
  
    
    switch f
        case 1          % Simuate nominal plant
            af=0;
            pf=0;
            sf=0;
        case 2          % Simulate blocked choke valve
            af=1;
            pf=0;
            sf=0;
        case 3          % Simulate pressure sensor fault
            af=0;
            pf=0;
            sf=1;
        case 4          % Simulate model error (washout/packoff)
            af=0;
            pf=1;
            sf=0;
    end
    %%%%%%%%%%%%%% PLANT %%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Volumes
    % her kalles volumes for  beregne V_d og V_a
    % len(i) er dh/dt ved tidspunkt i se seksjon 1.
    [V_d, V_a] = volumes(len(i));
    test1(i)=V_a;
    %%%%%%%%%%%%%%%%%% Actuators %%%%%%%%%%%%%%%%%%%
    switch af
        case 0
            % Choke flow 
            if (feil==true)          
                q_c(i) = Cv*sat((u_ctest(i)-u0),0,0).*sqrt(sp_c(i))/1000/60;       % sperret choke ventil. Se lignong 4.1 i modeling and simulation.
            else
                %q_c(i) = Cv*sat((u_ctest(i)),0,umax).*sqrt(sp_c(i))/1000/60;      % 
                q_c(i) = Cv*u_ctest(i).*sqrt(sp_c(i))/1000/60;      % 
                %q_c(i) = Cv*u_c(i).*sqrt(sp_c(i))/1000/60;  
            end
            
            if q_c(i)<=0,
            q_c(i)=0;
            elseif q_p(i)==0,
                q_c(i)=Cv*u_ctest(i).*sqrt(sp_c(i))/1000/60;
            end  
            
        case 1
            q_c(i)=0;
    end

    
    % depth = ... XXX
    % modell for trykktap i brnn kan forbli uendret intil videre.

    %%%%%%%%%%% plant Model %%%%%%%%%%%%%%%%%%%%%%%%%%%   
    Dph_p = Dph_pipe(depth,sp_p(i)) - 1*1.7;                                    % gravutasjons tap i pipe                               
    Dph_a = Dph_ann(depth,sp_c(i-1)) - 1*1.7; % + (i/length(time_s))*1.5;       % gravitasjons tap i annulus

%     Dp_p = Dp_pipe(1000*60*sq_b(i),len(i)) + (60-0*1.5)*( sq_b(i)/(2/60) )^2; % 60 bar wrong!                          % friksjonstap i pipe     
%     Dp_a = Dp_ann(1000*60*sq_b(i),len(i)) + 1*4*( sq_b(i)/(2/60) )^2 + 1*2*(sq_b(i)/(2/60))^2*(abs(N_RPM(i))/120)-1*3; % friksjonstap i annulus
%      
    % Kaasa model
    Dp_p = 160*( sq_b(i)/(2/60) )^2;
    Dp_a = 14.7*( sq_b(i)/(2/60) )^2;

    p_bd = sp_p(i) + Dph_p - Dp_p;      % Trykk i downhole bit
    p_ba = sp_c(i) + Dph_a + Dp_a;      % Trykk downhole annulus
    test2(i)=p_bd;
    test3(i)=p_ba;

    % endriner i choke trykk og strmmning.    
    %dp_p = (beta_d/V_d)*(q_p(i) - sq_b(i));                                                                                                                 % endret
    %dp_p = (beta_d/V_d)*(0.033 - sq_b(i)); 
    test =2;
    
    switch test     % tester plant_funksjon som skal bli feil tolerant opp mot modell.
        case 1
            dp_p = (beta_d/V_d)*(q_p(i) - sq_b(i));
            dp_c = (beta_a/V_a)*(sq_b(i) + q_r + sq_bpp(i) - q_c(i));
    
            if (sq_b( i) == 0) && (sp_p(i) + Dph_p - sp_c(i) - Dph_a < Dp_p + Dp_a),    % If struktur p grunn av enveis ventil i 
                dq_b = 0;                                                               % endring av strmning i bit
            else
            dq_b = (1/(M_d+M_a))*(p_bd-p_ba); % XXX                                     % endring av strmning i bit ellers
            end
        case 2
            var=[q_p(i),sq_b(i),q_r,sq_bpp(i),q_c(i),sp_p(i),sp_c(i),p_bd,p_ba];
            param=[beta_d,V_d,beta_a,V_a,M_d,M_a];
            [dp_p,dp_c,dq_b]=plant_model(f,var,Dp_p,Dp_a,Dph_p,Dph_a,param);
    end
    test4(i)=dp_c;
    dq_bpp=0;       % Denne endres etter at jeg har klart  stille inn PI controller til q_c.
    
    %%%%% beregner for neste tidsskritt %%%%%%%%%%%%%%
    sp_p(i+1) = sp_p(i) + h*dp_p;    
    sp_c(i+1) = sp_c(i) + h*dp_c;
    
    if (sp_c(i+1)<0),
    sp_c(i+1)=0;
    end
    % sbpp_p = ? Dette m jeg finne ut av.
    sq_b(i+1) = sq_b(i) + h*dq_b; if sq_b(i+1)<0, sq_b(i+1)=0; end
    
    % Mle 
    if (sq_b(i) <5/1000/60), 
        sp_b(i) = sp_c(i) + Dph_a;
    else
       sp_b(i) = sp_c(i) + Dph_a + Dp_a;
    end
    
    
    y1(i)=sp_c(i);
    y2(i)=sp_b(i);  
    %e2(i)=(-u_ptest(i)-u_ctest(i));
    
    %%%%%%%%%%%%%%%FAULT DETECTION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    %%%%%%%%%%%%%%% FAULT ACCOMODATION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % define set B which includes all observable faults.
%     if f==2,
%     k=1+k;
%     end
%     if k==3,
%         df=f;
%     end
%     if f==1
%         df=f;
%     end
   df=f;
    % Simulates that the fault is known.
    switch df
       case 1          % simuate nominal plant
            daf=0;
            dpf=0;
            dsf=0;
        case 2          % simulate blocked choke valve
            daf=1;
            dpf=0;
            dsf=0;
        case 3          % simulate pressure sensor fault
            daf=0;
            dpf=0;
            dsf=1;
        case 4          % simulate model error (washout/packoff)
            daf=0;
            dpf=1;
            dsf=0;
    end 
end

%%
lw = 1.5;
figure(5); hold on;
plot(s1.Time_h*60,s1.APRESM+1,'m.','Markersize',5); 
%plot(s1.Time_h,s1.APRESR+1,'c.','Markersize',5); 
plot(s1.Time_h*60,s1.APRESR+1,'m','linewidth',lw); 
plot(s2.t/60,s2.p_bit+1,'c','linewidth',lw);
plot(time_s/60,sp_b,'linewidth',lw);
%ylim([230 244])
xlabel('Time [min]');
ylabel('Downhole pressure [bar]')
hold off;

PRINT = 1;
if PRINT,
    %print -depsc2 s070401t2000t2300_pbit.eps
    %print -depsc2 s070401t2000t2300_kaasa_pbit.eps
end

figure(6); 
subplot(211)
plot(s2.t/60,s2.p_p+1,'r--'); hold on;
plot(time_s/60,sp_p(1:end-1)); hold off;
%xlabel('Time [min]');
ylabel('Standpipe pressure [bar]')
subplot(212)
%figure(7); 
plot(s2.t/60,s2.q_p,'r--'); hold on;
plot(time_s/60,1000*60*sq_b(1:end-1)); hold off;
xlabel('Time [min]');
ylabel('Flow [lpm]')

if PRINT,
    %print -depsc2 s070401t2000t2300_pp.eps
    %print -depsc2 s070401t2000t2300_kaasa_pp.eps
end

figure(8); 
plot(s2.t/60,s2.p_c+1,'r--'); hold on;
plot(time_s/60,sp_c(1:end-1)); hold off;
xlabel('Time [min]');
ylabel('Choke pressure [bar]')